<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode Proyek</label>
            <b-form-input
              size="lg"
              v-model="filter.id_project"
              placeholder="Masukkan Kode Proyek"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nomor Surat</label>
            <b-form-input
              size="lg"
              placeholder="Masukkan Nomor Surat"
              v-model="filter.letter_number"

            ></b-form-input>
          </div>

        </div>

        <div class="row">

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nickname</label>
            <b-form-input
              size="lg"
              placeholder="Masukkan Nickname"
              v-model="filter.nickname"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Subject</label>
            <b-form-input
              size="lg"
              placeholder="Masukkan Subject"
              v-model="filter.subject"

            ></b-form-input>
          </div>

        </div>

          <div class="row">

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Tanggal Surat</label>
            <b-form-input
              id="input-large"
              size="lg"
              type="date"
              v-model="filter.letter_date"
            ></b-form-input>
          </div>


        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md" @click="onSearch">
            <i class="flaticon2-search-1" ></i> Cari
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="d-flex my-3 justify-content-end">
        <button class="btn btn-success btn-md" @click="showAddModal">
          <i class="flaticon-add"></i>
        </button>
      </div>

      <div class="card-body p-0">
        <div class="table-responsive">
          <table
            class="table table-head-custom table-vertical-center table-head-bg table-borderless"
          >
            <thead>
              <tr class="text-left">
                <th style="min-width: 100px" class="pl-7">
                  <span class="text-dark-75">Nickname</span>
                </th>
                <th style="min-width: 100px">Type</th>
                <th style="min-width: 100px">Tanggal Surat</th>
                <th style="min-width: 100px">Nomor Surat</th>
                <th style="min-width: 100px">Subject</th>
                <th style="min-width: 100px">PIC</th>
                <th style="min-width: 100px">Dari</th>
                <th style="min-width: 100px">Tujuan</th>
                <th style="min-width: 101px">Aksi</th>
              </tr>
            </thead>

            <tbody>
              <template v-for="(item, i) in this.currentLettering">
                <tr v-bind:key="i">
                  <td class="pl-0 ">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.project.nickname }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.letter_type }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.date }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.code }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.subject }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.pic_code }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.from }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.to }}
                    </span>
                  </td>

                  <td class="pr-0">
                    <a
                      class="btn btn-light-success font-weight-bolder font-size-sm"
                      @click="showEditModal(item)"
                    >
                      <i class="flaticon-edit"></i>
                    </a>

                    <a
                      class="btn btn-light-danger font-weight-bolder font-size-sm ml-2"
                      @click="showDeleteModal(item)"
                    >
                      <i class="flaticon-delete"></i>
                    </a>
                  </td>
                </tr>
              </template>
            </tbody>
          </table>
        </div>
      </div>
    </div>
    
    <b-modal ref="add-letter" hide-footer title="Form Tambah Letter" size="lg">
      <div class="d-block text-center">

        <div class="row">
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">No. Surat</label>

             <b-form-input
              id="input-large"
              size="lg"
              placeholder="No. Surat"
              v-model="form.code"
            ></b-form-input>
          </div>
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Kode Proyek</label>

            <b-form-select
              v-model="form.id_project"
              :options="options.project"
              size="lg"
            ></b-form-select>
          </div>

        </div>

        <div class="row">
          
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">PIC</label>

            <b-form-select
              v-model="form.pic_code"
              :options="options.pic"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Type</label>

            <b-form-select
              v-model="form.letter_type"
              :options="options.letter_type"
              size="lg"
            ></b-form-select>
          </div>


        </div>

        <div class="row">
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Dari</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Letter Dari"
              v-model="form.from"
            ></b-form-input>
          </div>
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Tujuan</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Letter Tujuan"
              v-model="form.to"
            ></b-form-input>
          </div>
        </div>

        <div class="row">
                    <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Tanggal Surat</label>

             <b-form-input
              id="input-large"
              size="lg"
              type="date"
              v-model="form.date"
            ></b-form-input>
          </div>
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Subject</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Letter Subject"
              v-model="form.subject"
            ></b-form-input>
          </div>


        </div>

         <div class="row">
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Follow Up</label>

             <b-form-select
              v-model="form.follow_up"
              :options="options.followUp"
              size="lg"
            ></b-form-select>
          </div>
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">File</label>

            <b-form-file
            v-model="form.file"
            placeholder="Choose a file or drop it here..."
            drop-placeholder="Drop file here..."
            ></b-form-file>
          </div>
        </div>

      </div>
      
      

      <div class="d-flex mt-2">
        <b-button ref="kt_simpan_lettering" class="btn btn-success mr-2" block @click="onSave"
          >Simpan</b-button
        >

        <b-button class="btn btn-secondary mt-0" block @click="closeAddModal"
          >Batal</b-button
        >
      </div>
    </b-modal>
   
    <b-modal ref="edit-letter" hide-footer title="Form Ubah Letter" size="lg">
      <div class="d-block text-center">

        <div class="row">
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">No. Surat</label>

             <b-form-input
              id="input-large"
              size="lg"
              placeholder="No. Surat"
              v-model="form.code"
              readonly
            ></b-form-input>
          </div>
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Kode Proyek</label>

            <b-form-select
              v-model="form.id_project"
              :options="options.project"
              size="lg"
            ></b-form-select>
          </div>

        </div>

        <div class="row">
          
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">PIC</label>

            <b-form-select
              v-model="form.pic_code"
              :options="options.pic"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Type</label>

            <b-form-select
              v-model="form.letter_type"
              :options="options.letter_type"
              size="lg"
            ></b-form-select>
          </div>


        </div>

        <div class="row">
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Dari</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Letter Dari"
              v-model="form.from"
            ></b-form-input>
          </div>
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Tujuan</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Letter Tujuan"
              v-model="form.to"
            ></b-form-input>
          </div>
        </div>

        <div class="row">
                    <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Tanggal Surat</label>

             <b-form-input
              id="input-large"
              size="lg"
              type="date"
              v-model="form.date"
            ></b-form-input>
          </div>
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Subject</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Letter Subject"
              v-model="form.subject"
            ></b-form-input>
          </div>


        </div>

         <div class="row">
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">Follow Up</label>

             <b-form-select
              v-model="form.follow_up"
              :options="options.followUp"
              size="lg"
            ></b-form-select>
          </div>
          <div class="col-md-6 py-2 col-sm-12 text-left">
            <label for="input-large">File</label>

            <b-form-file
            v-model="form.file"
            placeholder="Choose a file or drop it here..."
            drop-placeholder="Drop file here..."
            ></b-form-file>
          </div>
        </div>

      </div>

      <div class="d-flex mt-2">
        <b-button ref="kt_update_lettering" class="btn btn-success mr-2" block @click="onUpdate"
          >Update</b-button
        >

        <b-button class="btn btn-secondary mt-0" block @click="closeEditModal"
          >Batal</b-button
        >
      </div>
    </b-modal>

    <b-modal ref="delete-letter" hide-footer title="Hapus Letter">
      <div class="d-block text-center mb-5 pb-5 pt-5">
        Apakah anda yakin ingin menghapus letter ?
      </div>

      <div class="d-flex mt-5">
        <b-button class="btn btn-success mr-2" block 
          >Hapus</b-button
        >

        <b-button class="btn btn-secondary mt-0" block @click="closeDeleteModal"
          >Batal</b-button
        >
      </div>
    </b-modal>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { GET_LETTERING,POST_LETTERING,PUT_LETTERING  } from "@/core/services/store/lettering.module";
import { mapGetters } from "vuex";
import { GET_PIC } from "@/core/services/store/pic.module";
import { GET_PROJECT_DETAIL } from "@/core/services/store/project.module.js";
import { showToast } from "@/core/helper/toast.helper";

export default {
  name: "lettering",
  data() {
    return {
      filter: {
        nickname:null,
        letter_date: null,
        letter_number: null,
        subject: null,
        id_project: null
      },
     
      data: {
        letter:{
          code : null,
          project : {
                  code : null,
                  name: null,
                  nickname :null,
              },
          letter_type : null,
          date : null,
          subject : null,
          pic : {
              code : null,
              name: null
          },
          from : null,
          to : null
        }
      },
      options: {
        followUp: [
          { value: 1, text: "YA" },
          { value: 0, text: "TIDAK" }
        ],
        letter_type: [
          { value: "in", text: "In" },
          { value: "out", text: "Out" },
          { value: "reply", text: "Reply" }
        ],
        project:[
           { value:null, text:null}
        ],
        pic:[
           { value:null, text:null}
        ]
      },
      form: {
        code : null,
        id_project: null,
        letter_type: null,
        date: null,
        subject: null,
        pic_code: null,
        from : null,
        to: null,
        follow_up:null
      }
    };
  },
  methods: {
    showAddModal() {
      this.form = {
        code : null,
        id_project: null,
        letter_type: null,
        date: null,
        subject: "",
        pic_code: null,
        from : "",
        to: "",
        follow_up:null
      };

      this.$refs["add-letter"].show();
    },

    closeAddModal() {
      this.$refs["add-letter"].hide();
    },

    addletter() {
      this.data.roles.push(this.form);

      this.closeAddModal();
    },

    showEditModal(letter) {
      console.log(letter)
      Object.assign(this.form, {
        code: letter.code,
        id_project: letter.project_code,
        letter_type: letter.letter_type,
        date: letter.date,
        subject: letter.subject,
        pic_code: letter.pic_code,
        from : letter.from,
        to: letter.to,
        follow_up:letter.follow_up
      });

      this.$refs["edit-letter"].show();
    },

    closeEditModal() {
      this.$refs["edit-letter"].hide();
    },

    showDeleteModal(letter) {
      Object.assign(this.form, {
        code: letter.code
      });

      this.$refs["delete-letter"].show();
    },

    closeDeleteModal() {
      this.$refs["delete-letter"].hide();
    },

    deleteletter() {
      //

    },

    mappingDataProject(projectList){
        this.options.project = []
        projectList.map(project => this.options.project.push({
            text:project.code + '-' + project.nickname,
            value:project.code
        }))
    },
    mappingDataPic(listpic){
        this.options.pic = []
        listpic.map(pic => this.options.pic.push({
            text:pic.code + '-' + pic.name,
            value:pic.code
        }))
    },

    onSearch(){
        this.$store.dispatch(GET_LETTERING, {params:this.filter});
    },

    mappingFormToObject(form){
        Object.assign(this.data.letter, {
            code : form.code,
            project : {
                    code : form.id_project,
                    name: null,
                    nickname :null,
            },
            letter_type : form.letter_type,
            date : form.date,
            subject : form.subject,
            pic : {
                code : form.pic_code,
                name: null
            },
            from : form.from,
            to : form.to
      });
    },

    onSave(){
      this.mappingFormToObject(this.form)
      const submitButton = this.$refs["kt_simpan_lettering"];
      submitButton.classList.add("spinner", "spinner-light", "spinner-right");

      setTimeout(() => {
        this.$store
          .dispatch(POST_LETTERING, this.data.letter)
          .then(() => {
            showToast("Notifikasi", "Data berhasil disimpan", "success")
            this.onSearch();
            this.closeAddModal();
            })
          .catch((error) => showToast("Notifikasi", error.data.message, "danger"));
          
        submitButton.classList.remove(
          "spinner",
          "spinner-light",
          "spinner-right"
        );

      }, 2000);
    },

    onUpdate(){
      this.mappingFormToObject(this.form)
      const submitButton = this.$refs["kt_update_lettering"];
      submitButton.classList.add("spinner", "spinner-light", "spinner-right");

      setTimeout(() => {
        this.$store
          .dispatch(PUT_LETTERING, this.data.letter)
          .then(() => {
            showToast("Notifikasi", "Data berhasil diubah", "success")
            this.onSearch();
            this.closeEditModal();
            })
          .catch((error) => showToast("Notifikasi", error.data.message, "danger"));
          
        submitButton.classList.remove(
          "spinner",
          "spinner-light",
          "spinner-right"
        );

      }, 2000);
    }

  },
  async mounted() {
    await this.$store.dispatch(SET_BREADCRUMB, [{ title: "Lettering" }]);
    await this.$store.dispatch(GET_LETTERING, {params:this.filter});
    await this.$store.dispatch(GET_PIC).then(
        () => this.mappingDataPic(this.currentPics)
    );
    await this.$store.dispatch(GET_PROJECT_DETAIL, "design" ).then(
        () => this.mappingDataProject(this.currentProjectDetails)
    );
    
  },
  computed: {
    ...mapGetters(["currentLettering","currentPics","currentProjectDetails"]),


  },
  
};
</script>

<style></style>
